<script setup lang="ts">
import { ref } from 'vue'

var isSearch = ref(false)

const clientNameList = [
  { value: 1, name: '張承翰' },
  { value: 2, name: '林淑婷' },
  { value: 3, name: '蔡恆善' },
  { value: 4, name: '劉逸春' },
  { value: 5, name: '李珮甄' },
  { value: 6, name: '洪晴淑' },
  { value: 7, name: '謝左彥' },
  { value: 8, name: '吳俊成' },
  { value: 9, name: '吳佳珠' },
  { value: 10, name: '王左鳳' },
  { value: 11, name: '許志豪' },
  { value: 12, name: '羅俊銘' },
  { value: 13, name: '賴哲豪' },
  { value: 14, name: '許威德' },
  { value: 15, name: '黎慧玲' },
  { value: 16, name: '郭重恬' },
  { value: 17, name: '林柏穎' },
  { value: 18, name: '葉中名' },
  { value: 19, name: '農允梅' },
  { value: 20, name: '許泰音' },
  { value: 21, name: '陳琦平' }
]

const fixBtn = {
  add: false,
  edit: false,
  delete: false
}

const tableHeaders = reactive([
  { title: '員工' },
  { title: '日期' },
  { title: '星期' },
  { title: '簽到時間' },
  { title: '簽退時間' },
  { title: '時數' },
  { title: '補登' }
])

const tableData = reactive([
  {
    employeeName: '王左鳳',
    date: '2023/02/01',
    week: '三',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/02',
    week: '四',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/03',
    week: '五',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/06',
    week: 'ㄧ',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/07',
    week: '二',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/08',
    week: '三',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/09',
    week: '四',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/10',
    week: '五',
    checkInTime: null,
    checkOutTime: null,
    hours: null,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/13',
    week: '一',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/14',
    week: '二',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/15',
    week: '三',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/16',
    week: '四',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  },
  {
    employeeName: '王左鳳',
    date: '2023/02/17',
    week: '五',
    checkInTime: '09:00',
    checkOutTime: '18:00',
    hours: 8,
    backfill: null
  }
])

const pageObj = reactive({
  pageItems: 10, // 一頁秀幾筆
  currentPage: 1, // 當前頁數
  pageSize: 5 // 分頁中間數字最多顯示的數目
})

// 總頁數
const totalPage = computed(() => {
  return Math.ceil(tableData.length / pageObj.pageItems)
})

const nowPage = computed(() => {
  const min = (pageObj.currentPage - 1) * pageObj.pageItems
  const max = min + pageObj.pageItems - 1
  return { min, max }
})

// 篩出來渲染的資料
const showData = computed(() => {
  return tableData.filter((item, index) => {
    return index >= nowPage.value.min && index < nowPage.value.max + 1
  })
})

const turnPage = (val: any) => {
  pageObj.currentPage = val
}

function onSubmit() {
  isSearch.value = true
}
</script>

<template>
  <main class="container-fluid">
    <header>
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="font-zh-small-regular breadcrumb-item">
            <a href="#">統計分析報表</a>
          </li>
          <li
            aria-current="page"
            class="font-zh-small-regular breadcrumb-item active"
          >
            業務出勤報表
          </li>
        </ol>
      </nav>
      <div class="d-flex justify-content-end w-100">
        <img
          alt="header-illustration"
          class="header-illustration"
          src="@/assets/images/header-illustration.svg"
        />
      </div>
      <div class="function-group">
        <div class="display-info">
          <h3 class="font-zh-h3">查詢業務出勤報表</h3>
          <div class="interact-button-list d-flex">
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>新增</p>
              <div class="icon-create"></div>
            </button>
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>匯出 Excel 檔</p>
              <div class="icon-export"></div>
            </button>
          </div>
        </div>
      </div>
    </header>
    <div class="single-operation-board card">
      <h3 class="font-zh-h3 text-color-main">查詢條件</h3>
      <form @submit.prevent="onSubmit">
        <div class="card-body">
          <div class="row">
            <div class="col-12">
              <div class="row align-items-end">
                <div class="col-3">
                  <div class="input-item">
                    <label class="font-zh-p-medium form-label" for="userAccount"
                      >開始日期</label
                    >
                    <common-calendar-date />
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <label
                      class="font-zh-p-medium form-label"
                      for="userPassword"
                      >結束日期</label
                    >
                    <common-calendar-date />
                  </div>
                </div>
              </div>
            </div>
            <div class="col-12">
              <div class="row align-items-end">
                <div class="col-3">
                  <div class="input-item">
                    <label class="font-zh-p-medium form-label" for="userAccount"
                      >業務代表</label
                    >
                    <common-select
                      v-model="clientNameValue"
                      :select-list-data="clientNameList"
                    />
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <div class="untitled-item form-check-item">
                      <input
                        id="checkbox"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-zh-p-medium form-check-label"
                        for="checkbox"
                      >
                        缺出勤紀錄
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-12">
              <div class="row align-items-end">
                <div class="col-3">
                  <div class="form-check-group">
                    <p class="font-en-p-medium">排序欄位</p>
                    <div class="form-check-list d-flex justify-content-between">
                      <div class="form-check">
                        <input
                          id="flexRadioDefault1"
                          class="form-check-input"
                          name="flexRadioDefault"
                          type="radio"
                        />
                        <label
                          class="font-en-p-medium form-check-label"
                          for="flexRadioDefault1"
                        >
                          員工
                        </label>
                      </div>
                      <div class="form-check">
                        <input
                          id="flexRadioDefault2"
                          class="form-check-input"
                          name="flexRadioDefault"
                          type="radio"
                        />
                        <label
                          class="font-en-p-medium form-check-label"
                          for="flexRadioDefault2"
                        >
                          出勤日期
                        </label>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="d-grid gap-2">
                    <button
                      class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                      type="submit"
                    >
                      <p>查詢</p>
                      <div class="icon-search"></div>
                    </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </form>
    </div>
    <div v-show="isSearch">
      <basic-table
        :fix-btn="fixBtn"
        :table-data="showData"
        :table-headers="tableHeaders"
      />
      <table-pagination
        :page-obj="pageObj"
        :total-page="totalPage"
        @turn-page="turnPage"
      />
    </div>
  </main>
</template>

<style lang="scss" scoped>
/** style */
</style>
